--[[
	RPButton main script file.
	Author: Jiltanith (Idea and Code for hiding the interface comes from ImmersionRP by: Shannae, Seagale)
	Written: April 2010
	Last update: October 2010
]]

RPButton = {
}

RPButtonVars = {
	RPMode = 0,
	RPButtonLocked = 0,
	RPButtonHidden = 0,
};

-- RPButtonButton:RegisterEvent("ADDON_LOADED");

function RPButtonButton_OnLoad()
	DEFAULT_CHAT_FRAME:AddMessage("RPButton - Hide/Show with /rpbutton show, type /rpbutton help for more info",0.5,0.5,0.9);
	RPButton.InitialiseSlashCommands();
	-- this:RegisterEvent("VARIABLES_LOADED")

	-- if (RPButtonVars.RPButtonHidden == 1) then
		-- DEFAULT_CHAT_FRAME:AddMessage("TEST passed / RPButton - Hide/Show with /rpbutton show, type /rpbutton help for more info",0.5,0.5,0.9);
		-- RPButtonButton:Hide();
	-- else
		-- DEFAULT_CHAT_FRAME:AddMessage("TEST failed / RPButton - Hide/Show with /rpbutton show, type /rpbutton help for more info",0.5,0.5,0.9);
	-- end
end

-- function frame:OnEvent(event)
	-- if event == "VARIABLES_LOADED" then
		-- DEFAULT_CHAT_FRAME:AddMessage("TEST 1 / RPButton - Hide/Show with /rpbutton show, type /rpbutton help for more info",0.5,0.5,0.9);
		-- if (RPButtonVars.RPButtonHidden == 1) then
			-- DEFAULT_CHAT_FRAME:AddMessage("TEST 2 / RPButton - Hide/Show with /rpbutton show, type /rpbutton help for more info",0.5,0.5,0.9);
			-- RPButtonButton:Hide();
		-- else
			-- DEFAULT_CHAT_FRAME:AddMessage("TEST failed / RPButton - Hide/Show with /rpbutton show, type /rpbutton help for more info",0.5,0.5,0.9);
		-- end
	-- end
 -- end


function RPButtonHandleSlashCommands(command)
	if (command == "show" or command == "hide") then
		if (RPButtonButton:IsVisible()) then
			RPButtonButton:Hide();
			RPButtonVars.RPButtonHidden = 1;
		else
			RPButtonButton:Show();
			RPButtonVars.RPButtonHidden = 0;
		end
	elseif (command == "rpmode") then
		RPButton.ToggleRPMode();
	elseif (command == "lock") then
		if (RPButtonVars.RPButtonLocked == 1) then RPButtonVars.RPButtonLocked = 0;
		else RPButtonVars.RPButtonLocked = 1;
		end
	elseif (command == "help" or command == "") then
		RPButton.PrintHelp();
	elseif (command == "resetpos") then
		RPButtonButton:ClearAllPoints();
		RPButtonButton:SetPoint("TOPLEFT",500,-300);
		RPButtonVars.RPButtonLocked = 0;
		RPButtonButton:Show();
		RPButtonVars.RPButtonHidden = 0;
	end
end

function RPButton.PrintHelp()
	DEFAULT_CHAT_FRAME:AddMessage("RPButton",0.5,0.5,0.9);
	DEFAULT_CHAT_FRAME:AddMessage("This addon will hide most of the interface - except chat - when going into RP mode");
	DEFAULT_CHAT_FRAME:AddMessage("- rpmode: Toggle RP Mode (This is also what the RP button does)");
	DEFAULT_CHAT_FRAME:AddMessage("- lock: Toggle wether the button can be moved or not");
	DEFAULT_CHAT_FRAME:AddMessage("- help: Show this help text");
	DEFAULT_CHAT_FRAME:AddMessage("- resetpos: Reset the Position and Visibility of the Button");
	DEFAULT_CHAT_FRAME:AddMessage("- show: Show/Hide the button (toggle)");
end

function RPButtonButton_OnClick()
	RPButton.ToggleRPMode();
end


function RPButton.InitialiseSlashCommands()
	SLASH_RPBUTTON1 = "/rpbutton";
	SlashCmdList["RPBUTTON"] = RPButtonHandleSlashCommands;
end


function RPButton.BindFrameToWorldFrame(frame)
	local scale = UIParent:GetEffectiveScale();
	frame:SetParent(WorldFrame);
	frame:SetScale(scale);
end

function RPButton.BindFrameToUIParent(frame)
	frame:SetParent(UIParent);
	frame:SetScale(1);
end

function RPButton.ToggleRPMode()
	if (RPButtonVars.RPMode == 0) then
		RPButton.EnableRPMode();
	else
		RPButton.DisableRPMode();
	end
end

function RPButton.EnableRPMode()
	RPButton.BindFrameToWorldFrame(GameTooltip);
	RPButton.BindFrameToWorldFrame(ChatFrame1EditBox);
	RPButton.BindFrameToWorldFrame(ChatFrameMenuButton);
	RPButton.BindFrameToWorldFrame(ChatMenu);
	RPButton.BindFrameToWorldFrame(RPButtonButton);
	for i = 1, 7 do
		RPButton.BindFrameToWorldFrame(getglobal("ChatFrame" .. i));
		RPButton.BindFrameToWorldFrame(getglobal("ChatFrame" .. i .. "Tab"));
		-- RPButton.BindFrameToWorldFrame(getglobal("ChatFrame" .. i .. "TabDockRegion"));
	end
	RPButtonVars.RPMode = 1;
	CloseAllWindows();
	UIParent:Hide();
end

function RPButton.DisableRPMode()
	RPButton.BindFrameToUIParent(GameTooltip);
	GameTooltip:SetFrameStrata("TOOLTIP");
	RPButton.BindFrameToUIParent(ChatFrame1EditBox);
	ChatFrame1EditBox:SetFrameStrata("DIALOG");
	RPButton.BindFrameToUIParent(ChatFrameMenuButton);
	ChatFrameMenuButton:SetFrameStrata("DIALOG");
	RPButton.BindFrameToUIParent(ChatMenu);
	ChatMenu:SetFrameStrata("DIALOG");
	RPButton.BindFrameToUIParent(RPButtonButton);
	for i = 1, 7 do
		RPButton.BindFrameToUIParent(getglobal("ChatFrame" .. i));
		RPButton.BindFrameToUIParent(getglobal("ChatFrame" .. i .. "Tab"));
		-- RPButton.BindFrameToUIParent(getglobal("ChatFrame" .. i .. "TabDockRegion"));
	end
	RPButtonVars.RPMode = 0;
	UIParent:Show();
end

function RPButton_OnDragStart(self)
		if (RPButtonVars.RPButtonLocked == 0) then
			self:StartMoving();
		end
end

function RPButton_OnDragStop(self)
	   self:StopMovingOrSizing();
end
